<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2003 *
 * ===============                              Last change: 12/03/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : stylesheet.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Stylesheets are stored here                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Style-Sheets werden hier abgelegt                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Default styles
$STYLES = array(
		'general.css',
);

// Add stylesheet for installation
if ((isInstalling()) || (!isInstalled())) $STYLES[] = 'install.css';

// When no CSS output-mode is set, set it to file-output
if (!isConfigEntrySet('css_php')) setConfigEntry('css_php', 'FILE');

// Output CSS files or content or link to css.php ?
if (($GLOBALS['output_mode'] == '1') || (getConfig('css_php') == 'DIRECT')) {
	// Load CSS files
	$STYLES = merge_array($STYLES, EXT_GET_CSS_FILES());

	// Output inclusion lines
	foreach ($STYLES as $value) {
		// Only include found CSS files (to reduce 404 requests)
		$basePath = sprintf("%stheme/%s/css/", constant('PATH'), getCurrentTheme());
		$FQFN = $basePath . $value;

		// Do include only existing files and whose are not empty
		if ((isFileReadable($FQFN)) && (filesize($FQFN) > 0)) {
			switch (getConfig('css_php')) {
				case 'DIRECT': // Just link them (unsupported)
					OUTPUT_HTML('<link rel="stylesheet" type="text/css" href="{!URL!}/theme/' . getCurrentTheme() . '/' . $value . '" />');
					break;

				case 'FILE': // Output contents
					OUTPUT_HTML(readFromFile($FQFN));
					break;

				default: // Invalid mode!
					debug_report_bug(sprintf("Invalid css_php value %s detected.", getConfig('css_php')));
					break;
			} // END - switch
		} // END - if
	} // END - foreach
} else {
	// Now we load all CSS files from css.php!
	OUTPUT_HTML('<link rel="stylesheet" type="text/css" href="{!URL!}/css.php', false);
	if ((isInstalling()) || (!isInstalled())) {
		// Default theme first
		$newTheme = 'default';
		if (REQUEST_ISSET_GET('theme'))  $newTheme = REQUEST_GET('theme');
		if (REQUEST_ISSET_POST('theme')) $newTheme = SQL_ESCAPE(REQUEST_POST('theme'));
		OUTPUT_HTML('?theme=' . $newTheme . '&amp;installing=1', false);
	} // END - if
	OUTPUT_HTML('" />');
}

//
?>
